#ifndef __CRC_H__
#define __CRC_H__

#ifdef __cplusplus
  extern "C" {
#endif

extern void *CRC16init(dword poly,dword flgs);   //Returns ERROR on error
extern void *CRC32init(dword poly,dword flgs);   //Returns ERROR on error
extern CRC16(word  crc,void *crc16table,void *buf,dword buflen,dword flags);
extern CRC32(dword crc,void *crc32table,void *buf,dword buflen,dword flags);

#ifdef __cplusplus
  }
#endif

//Flags for CRC16init(),CRC32init(),CRC16(),CRC32()
#define CRC_SHIFT_NORM  0
#define CRC_SHIFT_REV   1

//Flags for CRC16(),CRC32()
#define CRC_METHOD1    0
#define CRC_METHOD2    2

//CCITT standard polynomials
#define CRC_POLY_XYZMODEM   0x1021
#define CRC_POLY_KERMIT     0x8404
#define CRC_POLY_ZMODEM32   0x04c11db7

#endif
