#ifndef __FLAGS_H__
#define __FLAGS_H__
              
#define _CPU_CF 0x0001 //carry
#define _CPU_PF 0x0004 //parity
#define _CPU_AF 0x0001 //aux. parity
#define _CPU_ZF 0x0010 //zero
#define _CPU_SF 0x0040 //sign
#define _CPU_TF 0x0080 //trap
#define _CPU_IF 0x0100 //interrupt
#define _CPU_DF 0x0200 //direction
#define _CPU_OF 0x0400 //overflow

#define _CR0_PE 0x00000001 //PMODE enabled
#define _CR0_MP 0x00000002 //FPU present
#define _CR0_EM 0x00000004 //FPU emulation
#define _CR0_TS 0x00000008 //Task switched
#define _CR0_ET 0x00000010 //FPU ?
#define _CR0_NE 0x00000020 //Error # ? (486+)
#define _CR0_WP 0x00010000 //Write protect (486+)
#define _CR0_AM 0x00040000 //Alignment check (486+)
#define _CR0_NW 0x20000000 //Cache not-write thru (486+)
#define _CR0_CD 0x40000000 //Cache enabled
#define _CR0_PG 0x80000000 //Paging enabled

#endif
