include dos.inc

ifndef __STDIO_H__
__STDIO_H__ equ 0

.code

BUFSIZ equ (4*1024)

externdef _fmode:word

gets proto :dword
puts proto :dword

print proto off:dword
fprint proto dev:dword,off:dword
printxy proto x:word,y:word,off:dword
printf proto str1:dword,args:vararg
vprintf proto str1:dword,args:dword
fprintf proto dev:dword,str1:dword,args:vararg
vfprintf proto dev:dword,str1:dword,args:dword

sprintf proto dest:dword,src:dword,args:vararg
vsprintf proto dest:dword,src:dword,args:dword

scanf proto src:dword,args:vararg
vscanf proto :dword,:dword
sscanf proto dest:dword,src:dword,args:vararg
vsscanf proto :dword,:dword,:dword

getchar proto
putchar proto :byte

fopen proto :dword,:dword
fclose proto :dword
fread proto :dword, :dword, :dword, :dword
fwrite proto :dword, :dword, :dword, :dword
fseek proto :dword,:dword,:byte
ftell proto :dword
fflush proto :dword
feof proto :dword
fgetc proto :dword
fgetchar proto
fputc proto :byte,:dword
fputchar proto :byte
fscanf proto :dword,:dword,:vararg
vfscanf proto :dword,:dword,:dword
fputs proto :dword,:dword
fgets proto :dword,:dword,:dword
ungetc proto :byte,:dword
_putch proto :word
setbuf proto :dword,:dword
setvbuf proto :dword,:dword,:byte,:dword
fileno proto :dword

_printf_siz proto str1:dword,args:vararg
_vprintf_siz proto str1:dword,args:dword

;unlink is defined in DOS.inc and STDIO.inc (so I don't want two proto's)
;or else for some reason MASM places it in the OBJ file as an EXTERN
;and then LIB granularity is destroyed
ifndef __DOS_H__
unlink proto strg:dword
endif

FILE struct
  flags dw ?    ; ANSI-C flags
  buftyp dw ?   ; Buffer type (_IO...)
  buf dd ?      ; Input/Output Buffer only used for file I/O to cache data
  dbuf dd ?     ; Default assigned buffer
  bufsiz dd ?   ; Size of the buffers
  ipos dd ?     ; When this reaches isiz then all input data is exhausted
  isiz dd ?     ; increased each time more data is read
  osiz dd ?     ; Amount of data in output buffer that needs to be flushed
  cpos dd ?     ; Current file pos
  handle dw ?   ; DOS handle
  lastop db ?   ; Last operation. Must fseek() if last is not the same
                ; as what is being done.
FILE ends

_LO_READ  equ 1     ;last operations
_LO_WRITE equ 2

_F_READ equ 001h                 ; Read only file        
_F_WRIT equ 002h                 ; Write only file       
_F_RDWR equ 003h                 ; Read/write flag       
_F_BUF  equ 004h                 ; Malloc'ed Buffer data 
_F_LBUF equ 008h                 ; line-buffered file (no seeksing allowed)
_F_ERR  equ 010h                 ; Error indicator       
_F_EOF  equ 020h                 ; EOF indicator         
_F_BIN  equ 040h                 ; Binary file indicator 
_F_IN   equ 080h                 ; Data is incoming      
_F_OUT  equ 100h                 ; Data is outgoing      
_F_TERM equ 200h                 ; File is a terminal    
;Defined for QLIB only
_F_NOBUF equ 400h                ; Stream is unbuffered
 ;There still is a buffer but it must be always flushed after each operation.
_F_STR  equ 800h                 ; Stream is a string ;Used for scanf() and such
_F_UBUF equ 1000h                ; User buffer provided (free() on fclose())

;Flags for FILE.buftyp and used in setvbuf(,,x)
_IOFBF equ 0
_IOLBF equ 1
_IONBF equ 2

externdef stdin:dword
externdef stdout:dword
externdef stderr:dword
externdef stdaux:dword
externdef stdprn:dword

endif

