.code
exp PROC, val:REAL8
    fld     val                                 ; load the value
    fcom    __EXP_MAX                           ; exceeded maximum?
    fstsw   ax                                  ; save status word in AX
    fwait                                       ; wait this shit be idle
    sahf                                        ; load flags with it
    jna @f
@@:
    fldl2e                                      ; load log 2 (base e)
    fmulp   st(1), st(0)                        ; mul them
    fld     st(0)                               ; copy st(0) to st(1)
    frndint                                     ; rount st(0)
    fxch    st(1)                               ; xchange st(1) for st(0)
    fsub    st(0), st(1)                        ; sub rounded from unrounded
    f2xm1                                       ; calc 2^x-1
    fld1                                        ; load 1.00
    faddp   st(1), st(0)                        ; add 1.00 to st(1)
    fscale                                      ; exponential function of a
    ffree   st(1)                               ; remove rounded value
    fwait
    ret
exp ENDP

log proc, val:REAL8
    fld     val                                 ; load the value
    ftst                                        ; compare with zero
    fstsw   ax                                  ; save status word in AX
    fwait                                       ; wait this shit be idle
    sahf                                        ; load flags with it

    fldln2                                      ; load natural log of 2
    fxch    st(1)                               ; xchange it with value
    fyl2x                                       ; calc y=log2(x)

    fwait
    ret
log ENDP

pow PROC, val:REAL8, power:REAL8

  local __t_r1:real8

    fld val
    fcomp __ZERO  
    fstsw ax
    fwait
    sahf
    .if zero?
      fld power
      fcomp __ZERO
      fstsw ax
      fwait
      sahf
      .if zero?      ;this is ANSI C specs
        fld1   ;load one!  (in reality 0**0 is INF - o well)
        fwait
        ret
      .endif
      fldz     ;0**power = 0 always
      fwait
      ret
    .endif
    fld power
    fcomp __ZERO
    fstsw ax
    fwait
    sahf
    .if zero?      ;this is ANSI C specs
      fld1   ;load one!
      fwait
      ret
    .endif

    callp log,val                           ; calculate log of val

    fld power                               ; load power

    fmulp   st(1), st(0)                    ; multiply them
    fstp    __t_r1                          ; save result
    
    callp exp,__t_r1                        ; calculate exp func of result

    fwait
    ret
pow  ENDP

log10 PROC, val:REAL8
    fld     val                                 ; load the value
    ftst                                        ; compare with zero
    fstsw   ax                                  ; save status word in AX
    fwait                                       ; wait this shit be idle
    sahf                                        ; load flags with it

    fldlg2                                      ; load log of 2
    fxch    st(1)                               ; xchange it wih value
    fyl2x                                       ; calc y=log2(x)
    fwait
    ret
log10 ENDP

