include src\qlib.inc
include stdio.inc
include dos.inc
include alloc.inc
include fcntl.inc  ;O_... constants
include string.inc

.code

fopen proc,fn:dword,flgs:dword
  local bot:byte
  pushad

  callp malloc,BUFSIZ+sizeof FILE
  cmp eax,NULL
  je __NULL
  mov edx,eax

  mov bot,0   ;has 'b' or 't' been used?
  ;scan flgs
  xor ecx,ecx
  xor ebx,ebx
  mov esi,flgs
@@:
  lodsb
  test al,al
  jz gotflgs
  .if al=='r'
    or ecx,O_RDONLY
    or ebx,_F_READ
  .elseif al=='w'
    or ecx,O_WRONLY or O_TRUNC or O_CREAT
    or ebx,_F_WRIT
  .elseif al=='b'
    or ecx,O_BINARY
    or ebx,_F_BIN
    mov bot,1
  .elseif al=='t'
    or ecx,O_TEXT
    or ebx,_F_LBUF
    mov bot,1
  .elseif al=='a'
    or ecx,O_APPEND or O_WRONLY or O_TRUNC or O_CREAT
  .elseif al=='+'
    and ecx,NOT O_WRONLY  ;remove this
;    and ecx,NOT O_RDONLY  ;remove this ;Not neccessary since it's zero
    or ecx,O_RDWR
    or ebx,_F_RDWR
  .endif
  jmp @b

gotflgs:

  .if !bot
    .if _fmode & O_BINARY
      or ecx,O_BINARY
      or ebx,_F_BIN
    .else
      or ecx,O_TEXT
      or ebx,_F_LBUF
    .endif
  .endif

  callp open,fn,ecx
  cmp eax,ERROR
  je __ERROR

  mov [edx].FILE.handle,ax
  mov eax,edx
  add eax,sizeof FILE
  mov [edx].FILE.buf,eax
  mov [edx].FILE.dbuf,eax       ;NEW : v2.11 b4
  mov [edx].FILE.lastop,0
  mov [edx].FILE.isiz,0
  mov [edx].FILE.ipos,0  ;when ipos==isiz then buffer is empty
  mov [edx].FILE.osiz,0
  mov [edx].FILE.flags,bx
  mov [edx].FILE.bufsiz,BUFSIZ
  mov [edx].FILE.buftyp,_IOFBF  ;NEW : v2.11 b4
  mov [edx].FILE.cpos,0  ;FIX : v2.11 Beta#4 : this was missing
__NULL:
  mov [esp].callstruct._eax,edx  ;Save EAX
  popad
  ret
__ERROR:
  callp free,edx
  popad
  mov eax,NULL
  ret
fopen endp

_endseg

end


