include src\qlib.inc
include stdio.inc
include dos.inc
include alloc.inc
include fcntl.inc  ;O_... constants
include string.inc

.code

setbuf proc uses edx,f:dword,buf:dword
  ;if NULL = unbuffered
  ;else full buffered (must by BUFSIZ in bytes)
  mov eax,buf
  mov edx,f
  callp fflush,edx
  test eax,eax
  jz __NULL
  mov [edx].FILE.buf,eax
  or [edx].FILE.flags,_F_UBUF  ;user buffer installed
  mov [edx].FILE.bufsiz,BUFSIZ
  xor eax,eax
  ret
__NULL:
  .if [edx].FILE.flags & _F_UBUF
    callp free,[edx].FILE.buf  ;release user buffer
    xor [edx].FILE.flags,_F_UBUF
  .endif
  mov eax,[edx].FILE.dbuf  ;default buffer
  mov [edx].FILE.buf,eax
  mov [edx].FILE.bufsiz,BUFSIZ
  xor eax,eax
  ret
setbuf endp

setvbuf proc uses edx,f:dword,buf:dword,typ:byte,siz:dword
  cmp typ,2
  ja bad
  mov edx,f
  callp fflush,edx
  mov eax,buf
  test eax,eax
  jnz @f
  cmp typ,_IONBF
  je nobuf
  ;malloc() a buffer
  callp malloc,siz
  test eax,eax
  jz bad
@@:
  .if [edx].FILE.flags & _F_UBUF
    callp free,[edx].FILE.buf  ;release old user buffer
  .endif
  mov [edx].FILE.buf,eax
  xor eax,eax
  mov al,typ
  mov [edx].FILE.buftyp,ax
  mov eax,siz
  mov [edx].FILE.bufsiz,eax
  or [edx].FILE.flags,_F_UBUF
  xor eax,eax
  ret
nobuf:
  mov [edx].FILE.buftyp,_IONBF
  .if [edx].FILE.flags & _F_UBUF
    callp free,[edx].FILE.buf  ;release user buffer
    xor [edx].FILE.flags,_F_UBUF
  .endif
  mov eax,[edx].FILE.dbuf  ;default buffer
  mov [edx].FILE.buf,eax
  mov [edx].FILE.bufsiz,BUFSIZ
  xor eax,eax
  ret
bad:
  mov eax,ERROR
  ret
setvbuf endp

_endseg

end

