include src\qlib.inc  ;setup
include src\math.inc
include dos.inc
include string.inc
include conio.inc
include stdlib.inc
include math.inc

.data?  ;starts DWORD aligned
  __t_s64 db 65 dup (?) ;one extra for NULL if needed
  __t_r1 REAL8 ?
  __t_r2 REAL8 ?
  __t_d1 dd ?

  _bak dd ?    ;bakup of ESI
  _width dd ?
  _pad dd ?    ;used with %s when width is used
  _dec dd ?    ;Presicion (DECiaml part of %f only)
  _starADD dd ? ;used to skip over 'star' fields

  _size dd ?   ;# of bytes
    ;default=32bit int
    ;       =32bit float
    ;l      =32bit int (useless piece of shit! - fucking AT&T)
    ;       =64bit double
    ;L      =80bit double
    ;h      =16bit int
    ;H      =8bit int

  epos dd ?    ;used for %f and %e
  esiz dd ? 
  _pos db ?    ;flag : use positive sign on signed #'s
  _zero db ?   ;flag : do not remove leading zeros
  _dot db ?    ;flag : . used with %f
  _decu db ?   ;flag : is _dec used?
  _alt db ?    ;flag : # is in use (alternative output)
  _star db ?   ;flag : * is in use (width/precision control)
  _capE db ?   ;flag : e in exp form should be capital (ie: E,G)
  _typ db ?    ;type : the char after the % (ie: d,x,X,c,s,f,e,E,g,G,b)
  _sizech db ? ;type : size mod char (l,L,h,H,N,F)

  _n dd ?      ;for %n
  m db ?

.code
decode_printf proc private  ;printf() decoder (see scanf.asm for ...scanf() version)
  ; in : esi=string (right after %)
  ;    : ebx=varargs
  ; out : eax=# bytes needed (if mode==0)
  ;     : _typ=char (c,s,d,...)
  ;     : _size=# bytes to add for varargs (4,8,10,etc.)
  ;     : _sizech=char (l,L,h,...)
  ;     : _width=byte (max=9999)
  ;     : _zero = T/F
  ;     : _pos = T/F

  mov m,0   ;width counter
  mov _pos,0
  mov _zero,0
  mov _width,0
  mov _dot,0
  mov _dec,0      ;decimal width for decimals (BC uses 6 which is dumb)
  mov _decu,0
  mov _bak,esi
  mov _sizech,0
  mov _alt,0
  mov _star,0
  mov _starADD,0
  mov _capE,0
@@:
  lodsb

;Check for #
  .if al=='#'
    .if _alt
      jmp bad
    .endif
    inc _alt
    jmp @b
  .endif

;Check for * (width/precision from arg list)
  .if al=='*'
    .if (m) || (_star)
      jmp bad
    .endif
    .if _dot
      mov eax,[ebx]
      mov _dec,eax
      add ebx,4
      mov _decu,1
      inc _star
      add _starADD,4
    .else
      mov eax,[ebx]
      mov _width,eax
      add ebx,4
      inc _star
      add _starADD,4
    .endif
    jmp @b
  .endif

;Check for width/precision
  .if al=='.'
    .if _dot
      jmp bad
    .endif
    inc _dot
    mov _star,0
    mov m,0  ;precision counter
    jmp @b
  .endif
  .if (al=='0') && (!_zero) && (!_width) && (!_dot)
    inc _zero
    jmp @b
  .endif
  .if (al=='+')
    .if _pos
      jmp bad
    .endif
    inc _pos
    jmp @b
  .endif
  .if (al>='0') && (al<='9')
    .if _star  ;* already used
      jmp bad
    .endif
    .if _dot
      mov _decu,1
      .if m > 5
        jmp bad
      .endif
      mov ecx,_dec
      imul ecx,10
      inc m
      sub al,'0'
      xor ah,ah
      add cx,ax
      mov _dec,ecx
      jmp @b
    .endif
    .if m > 5
      jmp bad
    .endif
    mov ecx,_width
    imul ecx,10
    inc m
    sub al,'0'
    xor ah,ah
    add cx,ax
    mov _width,ecx
    jmp @b
  .endif

;Check for size mods char
  .if (al=='l') || (al=='L') || (al=='N') || (al=='F') || (al=='h') || (al=='H')
    .if _sizech
      jmp bad  ;already got one
    .endif
    mov _sizech,al
    jmp @b
  .endif

;Check for conversion type char
  .if (al=='f') || (al=='e') || (al=='E') || (al=='g') || (al=='G')
    mov _typ,al
    .if (al=='E') || (al=='G')
      inc _capE
    .endif
    mov al,_sizech
    .if al==0
      mov _size,8  ;double
      add ebx,4    ;add an extra 4 bytes
    .elseif al=='l'
      mov _size,8  ;double
      add ebx,4    ;add an extra 4 bytes
    .elseif al=='L'
      mov _size,12 ;long double  (but it's DWORD aligned!)
      add ebx,8    ;add an extra 8 bytes  (DWORD aligned!)
    .else
      jmp bad      ;unknown thing
    .endif
    mov eax,64   ;Max length of %f
    jmp done
  .endif
  .if (_dot)
    jmp bad
  .endif

  .if al=='b'
    mov _typ,al  ;binary
    mov al,_sizech
    .if (al!=0) && (al!='l') && (al!='h') && (al!='H')
      jmp bad
    .endif
    mov _size,4
    mov eax,33   ;Max length of %b (binary)
    jmp done
  .endif

  .if al=='o'
    mov _typ,al ;octal
    mov al,_sizech
    .if (al!=0) && (al!='l') && (al!='h') && (al!='H')
      jmp bad
    .endif
    mov _size,4
    mov eax,17
    jmp done
  .endif

  .if (al=='x') || (al=='X')
    mov _typ,al ;hex
    mov al,_sizech
    .if (al!=0) && (al!='l') && (al!='h') && (al!='H')
      jmp bad
    .endif
    mov _size,4
    mov eax,9
    .if _alt
      add eax,2  ;for 0x or 0X
    .endif
    jmp done
  .endif

  .if al=='u'
    mov _typ,al   ;unsigned
    mov al,_sizech
    .if (al!=0) && (al!='l') && (al!='h') && (al!='H')
      jmp bad
    .endif
    mov _size,4
    mov eax,11
    jmp done
  .endif

  .if al=='d' || al=='i'
    mov _typ,al   ;signed
    mov al,_sizech
    .if (al!=0) && (al!='l') && (al!='h') && (al!='H')
      jmp bad
    .endif
    mov _size,4
    mov eax,12
    jmp done
  .endif

  ;not allowed for pointers
  .if (_zero) || (_pos) || (_dot)
    jmp bad
  .endif

  .if al=='p'
    mov _typ,al
    mov al,_sizech
    .if al==0
      mov eax,4  ;32bit
    .elseif al=='N'
      mov eax,4  ;same fucking thing!?
    .elseif al=='F'
      mov eax,8
      add ebx,4    ;add an extra 4 bytes
    .else
      jmp bad
    .endif
    mov _size,eax  ;_size is same as eax
    jmp done
  .endif

  ;not allowed for strings or chars or %n
  .if (_sizech)
    jmp bad
  .endif

  .if al=='n'
    mov _typ,al
    mov _size,4
    jmp done
  .endif

  .if al=='s'   ;string
    mov _typ,al
    mov eax,[ebx]
    callp strlen,eax
    .if eax < _width
      mov ecx,_width
      mov _pad,ecx
      sub _pad,eax
      mov eax,ecx
    .endif
    mov _size,4  ;32bit Address
    jmp done
  .endif

  .if al=='c'
    mov _typ,al
    mov eax,1
    mov _size,eax
    jmp done
  .endif

  jmp bad  ;unknown type!

done:
  .if _width > eax   ;make sure to return largest #
    mov eax,_width
  .endif
  add ebx,4   ;move to next element
  ret
bad:
  mov esi,_bak
  mov _typ,0
  mov _sizech,0
  xor eax,eax
  ret
decode_printf endp

_printf_siz proc,str1:dword,args:vararg
  ;calculate maximum RAM required for string when all % expanded.
  ; out : eax = max size needed
  lea eax,args
  callp _vprintf_siz,str1,eax
  ret
_printf_siz endp

_vprintf_siz proc,str1:dword,args:dword
  local siz:dword
  pushad
  mov esi,str1
  mov ebx,args
  mov siz,0
@@:
  cmp byte ptr[esi],0
  jz @f
  cmp byte ptr[esi],'%'
  jz @@per
  inc siz
  inc esi
  jmp @b
@@per:
  inc esi
  cmp byte ptr[esi],'%'
  jnz @@per2
  inc esi
  inc siz  ;just one % will go out
  jmp @b
@@per2:
  call decode_printf
  .if !eax
    inc siz ;for the % (w/ error)
  .elseif
    add siz,eax
  .endif
  jmp @b
@@:
  inc siz ;for the 0
  popad
  mov eax,siz
  ret
_vprintf_siz endp                                    

;prints into string
sprintf proc,buf:dword,str1:dword,args:vararg
  lea eax,args
  callp vsprintf,buf,str1,eax
  ret
sprintf endp

vsprintf proc,buf:dword,str1:dword,args:dword
  ;prints C type string from src => dest

  ; % [+][0][width] type
  ; type=[d],[o],[x],[X],[b],[c],[s],[%],[f]

  ; +=use + when printing signed #'s
  ; 0=keep all leading zeros 
  ; x,X=hex output (as in C)
  ; b=binary output
  ; d=decimal output
  ; c=char
  ; s=string
  ; f=double

  ; FIX : v2.00 Beta #2 : this was not preserving regs!
  ; FIX : v2.11 Beta #2 : locals now allowed

  local __r_int:real8,__r_rnd:real8,__r_rnd2:real8,__r_pow:real8
  local __t_rndd1:dword,__t_rndd2:dword

  pushad

  mov esi,str1
  mov edi,buf
  mov ebx,args
  mov _n,0

@@top:
  mov al,[esi]
  cmp al,0
  jz __end
  cmp al,'%'
  jz @@per
@@per1:
  movsb
  inc _n
  jmp @@top
@@per: ; % is use
  inc esi
  mov al,[esi]
  cmp al,'%'
  jz @@per1    ;2 % = 1 %
  push ebx
  call decode_printf
  pop ebx  ;I will change EBX on my own
  add ebx,_starADD  ;skip over * fields used
  mov al,_typ
  test al,al
  jz __end

  mov cl,_sizech
  cmp al,'u'
  jz @@peru
  cmp al,'i'
  jz @@perd
  cmp al,'d'
  jz @@perd
  cmp al,'x'
  jz @@perx
  cmp al,'X'
  jz @@perxc
  cmp al,'c'
  jz @@perc
  cmp al,'o'
  jz @@pero
  cmp al,'b'
  jz @@perb
  cmp al,'e'
  jz @@pere
  cmp al,'E'
  jz @@pere
  cmp al,'f'
  jz @@perf
  cmp al,'g'
  jz @@perg
  cmp al,'G'
  jz @@perg
  cmp al,'p'
  jz @@perp
  cmp al,'n'
  jz @@pern
;must be 's'
  .if _width && _pad
    mov eax,20202020h  ;spaces
    mov ecx,_pad
    add _n,ecx
    _storeECX dl  ;destroys DL
  .endif
  callp strcpy,edi,[ebx]
  callp strlen,[ebx]
  add edi,eax
  add ebx,4  ;must be 4
  jmp @@top

@@pern:
  mov ecx,[ebx]  ;SS:
  mov eax,_n
  mov [ecx],eax
  add ebx,_size
  jmp @@top

@@perp:
  callp num2str,[ebx],offset __t_s64,16
  .if cl=='F'
    mov bptr[__t_s64+8],':'
    callp num2str,[ebx+4],offset __t_s64+9,16
  .endif
  jmp addstr

@@perf:
  .if !_decu
    mov _dec,6
  .elseif _dec > 40
    mov _dec,40  ;no more than this is needed
  .endif
  call convert_float
@@perf_:
  callp ftoa,__t_r1,offset __t_s64,_dec
  jmp addfstr

@@pere:
  .if !_decu
    mov _dec,6
  .elseif _dec > 40
    mov _dec,40  ;no more than this is needed
  .endif
  call convert_float
@@pere_:
  callp etoa,__t_r1,offset __t_s64,_dec
  jmp addfstr  ;changes 'e' to 'E' if _typ=='E' or 'G'

@@perg:
  .if !_decu
    mov _dec,6
  .elseif _dec > 40
    mov _dec,40  ;no more than this is needed
  .endif
  call convert_float
;If number is zero then use %f
  frnd __t_r1,_dec
  fld __t_r1
  ftst   ;cmp 0.0
  ffree st(0)
  fstsw ax
  sahf
  jz @@perf_
;If number is smaller than precision will show then %e is used, else %f is used
  ;num=pow(10,-_dec)
  mov eax,_dec
  neg eax
  mov __t_d1,eax
  fild __t_d1
  fstp __t_r2
  callp pow10,__t_r2
  ;ST(0) = size of precision
  fld __t_r1

  ;ST(0) = number
  ;ST(1) = size of precision (BUGGY)
  fcompp ;ST(0) - ST(1) and pop both
  fstsw ax
  sahf
  jc @@pere_
  jmp @@perf_

@@perb:
  callp num2str,[ebx],offset __t_s64,2
  jmp addstr
@@pero:
  callp num2str,[ebx],offset __t_s64,8
  jmp addstr
@@perd:
  callp num2strs,[ebx],offset __t_s64,10     ;signed!
  jmp addstr
@@peru:
  callp num2str,[ebx],offset __t_s64,10      ;unsigned!
  jmp addstr
@@perx:    ;hex w/ lower case
  callp num2str,[ebx],offset __t_s64,16
  jmp addstr
@@perxc:   ;hex w/ upper case
  callp num2strc,[ebx],offset __t_s64,16
  jmp addstr
@@perc:
  mov al,[ebx]
  mov [edi],al
  inc _n
  inc edi
  add ebx,4    ;no byte pushes possible
  jmp @@top
__end:
  mov byte ptr[edi],0
  popad
  xor eax,eax
  ret
addstr:
  add ebx,_size   ;move to next var.
  ;copy __t_s64 to edi based on _*
  push esi
  mov esi,offset __t_s64
  .if (_pos) && (bptr[esi]!='-')
    mov eax,esi
    inc eax
    callp memcpy,eax,esi,sizeof __t_s64 - 1
    mov bptr[esi],'+'
  .endif
  .if _alt && _zero
    .if _typ=='x'
      mov ax,'x0'
      stosw
      add _n,2
    .elseif _typ=='X'
      mov ax,'X0'
      stosw
      add _n,2
    .endif
  .endif
  callp strlen,esi
  mov edx,eax
  .if _alt && ( (_typ=='x') || (_typ=='X') )
    add eax,2
  .endif
  .if eax < _width
    mov ecx,_width
    sub ecx,eax
    mov al,[esi]
    .if ( ( (al=='-') || (al=='+') ) && _zero )
      movsb
      inc _n
      dec edx
    .endif
    .if _zero
      mov eax,'0000'
    .else
      mov eax,20202020h
    .endif
    add _n,ecx
    push ebx
    _storeECX bl  ;destroys BL
    pop ebx
  .endif
  .if _alt && !_zero
    .if _typ=='x'
      mov ax,'x0'
      stosw
      add _n,2
    .elseif _typ=='X'
      mov ax,'X0'
      stosw
      add _n,2
    .endif
  .endif
  mov ecx,edx
  add _n,ecx
  copyECX  ;destroys AL
  pop esi
  jmp @@top
addfstr:  ;special for %f,e,g,E,G
  add ebx,_size   ;move to next var.
  ;copy __t_s64 to edi based on _*
  push esi
  mov esi,offset __t_s64
  .if (bptr[esi+1]=='N') || (bptr[esi+1]=='I')   ;was it NAN or INF?
    mov edx,4
    mov _zero,0
    mov epos,0
    mov esiz,0
    jmp specialperf
  .endif
  .if (_pos) && (bptr[esi]!='-')
    mov eax,esi
    inc eax
    callp memcpy,eax,esi,sizeof __t_s64 - 1
    mov bptr[esi],'+'
  .endif
  push ebx
  call flen  ;EBX= whole length  ECX=pos of e EDX=size of e
  .if (ecx) && (_capE)
    mov al,_typ
    .if (al=='E') || (al=='G')
      mov bptr[ecx],'E'
    .endif
  .endif
  mov epos,ecx
  mov esiz,edx
  add edx,ebx
  pop ebx
  add edx,_dec  ;6+1 for dec pt
  ;if _dec is zero then the decimal should not be printed
  .if _dec || _alt
    inc edx     ;include the dec pt
  .endif
specialperf:
  .if edx < _width
    mov ecx,_width
    sub ecx,edx
    mov al,[esi]
    .if ( ( (al=='-') || (al=='+') ) && _zero )
      movsb
      inc _n
      dec edx  ;just outputed 1 byte now so do not do it l8r
    .endif
    .if _zero
      mov eax,'0000'
    .else
      mov eax,'    '
    .endif
    add _n,ecx
    push ebx
    _storeECX bl  ;destroys BL
    pop ebx
  .endif
  mov ecx,edx
  sub ecx,esiz
  add _n,ecx
  copyECX  ;destroys AL  ;move # first
  .if epos   ;is there an exp part
    mov esi,epos  ;move to exp part
    mov ecx,esiz
    add _n,ecx
    copyECX  ;destroys AL
  .endif
  pop esi
  jmp @@top
vsprintf endp

convert_float proc private
  ;Input : cl = size mod char
  ;      : [ebx] = float/double/long double
  ;Output: __t_r1 = double
  .if cl=='L'
    ;convert 'long double' to 'double'
    fld REAL10 PTR[ebx]
;  .if cl=='l'
;    fld REAL8 PTR[ebx]
  .else
    ;convert 'double' to 'double'
    fld REAL8 PTR[ebx]
  .endif
  fstp __t_r1
  _fwait
  ret
convert_float endp

;ret: EBX=whole len ECX=pos of e if exp # (ie: 1e3) else 0 EDX=size of exp part
;in : esi = string
flen proc private  ;PRIVATE + USES = possible MASM bug
  push esi  ;uses esi,ebx
  xor ebx,ebx
  xor ecx,ecx
  xor edx,edx
  lodsb
  .while al!='.' && al!='e' && al!=0
    inc ebx
    lodsb
  .endw
  .if al==0
    pop esi
    ret
  .endif
  .if al=='e'
    jmp e1
  .endif
  lodsb
  .while al!='e' && al!=0
    lodsb
  .endw
  .if al==0
    pop esi
    ret
  .endif
;exp form detected
e1:
  mov ecx,esi
  dec ecx
  inc edx        ;inc for the 'e'
  lodsb
  .while al!=0
    inc edx
    lodsb
  .endw
  pop esi
  ret
flen endp

_endseg

end

