include src\qlib.inc  ;setup
include dos.inc
include string.inc
include alloc.inc
include stdio.inc
include conio.inc
include key.inc

.data?   ;starts DWORD aligned
  tok dd ?     ;token pos (see strtok())
  tokend dd ?  ;token end

.code
strchr proc uses edi ecx,s1:dword,c1:byte
  mov edi,s1
  callp strlen,edi
  mov ecx,eax
  mov al,c1
  repnz scasb
  .if zero?
    dec edi    ;go back to c1
    mov eax,edi
    ret
  .endif
  xor eax,eax  ;else ret NULL
  ret
strchr endp

strcspn proc,s1:dword,s2:dword
  local pos:dword
  pushad
  mov edx,s2
  mov edi,edx
  mov esi,s1
  callp strlen,edi
  mov ebx,eax
  inc ebx  ;must count NULL too
  mov pos,0
@@:
  mov ecx,ebx
  lodsb
  repnz scasb
  .if zero?
    popad
    mov eax,pos
    ret
  .endif
  inc pos
  mov edi,edx
  jmp @b
strcspn endp

strspn proc,s1:dword,s2:dword
  local pos:dword
  pushad
  mov edx,s2
  mov edi,edx
  mov esi,s1
  callp strlen,edi
  mov ebx,eax
  inc ebx  ;must count NULL too
  mov pos,0
@@:
  mov ecx,ebx
  lodsb
  repnz scasb
  .if !zero?
    popad
    mov eax,pos
    ret
  .endif
  inc pos
  mov edi,edx
  jmp @b
strspn endp

strdup proc,s1:dword
  callp strlen,s1
  inc eax  ;for NULL
  callp malloc,eax
  .if eax==NULL
    ret
  .endif
  callp strcpy,eax,s1    ;will return eax
  ret
strdup endp

strpbrk proc,s1:dword,s2:dword
  local pos:dword
  pushad
  mov edi,s2
  mov esi,s1
  callp strlen,edi
  mov ebx,eax
  callp strlen,esi
  mov edx,eax
;  inc ebx  ;DO NOT count NULL
  mov pos,0
@@:
  mov ecx,ebx
  lodsb
  repnz scasb
  .if zero?
    popad
    mov eax,pos
    add eax,s1
    ret
  .endif
  inc pos
  mov edi,s2
  dec edx
  jnz @b
  popad
  xor eax,eax
  ret
strpbrk endp

strrchr proc uses edi ecx,s1:dword,c1:byte
  mov edi,s1
  callp strlen,edi
  mov ecx,eax
  mov al,c1
  std
  repnz scasb
  .if zero?
    inc edi    ;go back to c1
    mov eax,edi
    ret
  .endif
  cld
  xor eax,eax  ;else ret NULL
  ret
strrchr endp

strrev proc,s1:dword
  pushad
  mov esi,s1
  callp strlen,esi
  .if !eax
    popad
    ret
  .endif
  mov edi,s1
  add edi,eax
  mov ecx,eax
  shr ecx,1
@@:
  mov al,[esi]
  mov ah,[edi]
  mov [esi],ah
  mov [edi],al
  inc esi
  dec edi
  dec ecx
  jnz @b
  popad
  mov eax,s1
  ret
strrev endp

strset proc uses edi ecx ebx,s1:dword,c1:byte
  mov edi,s1
  callp strlen,edi
  mov ecx,eax
  mov al,c1
  storeECXinital   ;destorys BX
  storeECX   ;destorys BL
  mov eax,s1
  ret
strset endp

strstr proc,s1:dword,s2:dword
  pushad
  mov esi,s1
  callp strlen,esi
  mov ecx,eax
  callp strlen,s2
  mov edx,eax
@@:
  callp memcmp,esi,s2,edx
  .if !eax
    mov [esp+7*4],esi
    popad
    ret
  .endif
  inc esi
  dec ecx
  jnz @b
  popad
  xor eax,eax
  ret
strstr endp

strtok proc,s1:dword,s2:dword
  pushad
  mov edi,s1
  cmp edi,NULL
  jz get_next_tok
;find 1st token
  callp strlen,s1
  add eax,s1
  mov tokend,eax
  call find_tok
  mov [esp+7*4],eax
  popad
  ret
get_next_tok:
  mov edi,tok
  .if !edi
    popad
    xor eax,eax
    ret
  .endif
  call find_tok
  mov [esp+7*4],eax
  popad
  ret

find_tok:
  ;edi=string (s1)
  mov esi,s2
  .if !esi    ;s2 should not be NULL
    xor eax,eax
    db 0c3h  ;ret
  .endif
  .if edi > tokend
    xor eax,eax
    mov tok,eax
    db 0c3h  ;ret
  .endif
  callp strlen,esi
  mov ebx,eax
  mov edx,edi
@@:
  callp memcmp,edi,esi,ebx
  .if !eax
    mov ecx,ebx
    xor eax,eax
    storeECX   ;destorys BL
    mov tok,edi  ;tok=next tok area for next time
  .else
    inc edi
    jmp @b
  .endif
@@:
;ret edi
  mov edi,edx
@@:
  .if ! bptr[edi]
    ;gotta move to next thing
    inc edi
    .if edi>tokend
      xor eax,eax
      mov tok,eax
      db 0c3h  ;ret
    .endif
    jmp @b
  .endif
  mov eax,edi
  db 0c3h  ;ret
strtok endp

;have no idea what this is for
;BC help was nohelp in explaining what it even does
;got this from BCv5.0 LIB hacks

strxfrm proc,dest:dword,src:dword,len:dword
  callp strlen,src
  .if eax>=len
    ret    ;return EAX as is
  .endif
  push eax
  inc eax
  callp memcpy,dest,src,eax
  pop eax
  ret
strxfrm endp

_endseg

end

