.data
align 4
g_copyblk_type dd offset copy2_modex,offset copy2_vesa,offset copy2_vesax
               dd offset copy2_linear,offset copy2_linearx

.code
;copys a part of _v_buffer to video RAM
align 4
g_copyblk proc,x1:dword,y1:dword,x2:dword,y2:dword
  local dadd:dword
  local sadd:dword
  local xl:dword,xlb:dword,yl:dword
  local _off:dword,_offx:dword
;ModeX locals
  local _off2:dword,_pc:byte,_xl2c:byte

  pushad

  mov eax,x1
  cmp eax,_v_win_x2
  jg niv

  mov ebx,x2
  cmp ebx,_v_win_x1
  jl niv

  mov ecx,y1
  cmp ecx,_v_win_y2
  jg niv

  mov edx,y2
  cmp edx,_v_win_y1
  jl niv

  assume eax:sdword,ebx:sdword,ecx:sdword,edx:sdword
  .if eax < _v_win_x1
    mov eax,_v_win_x1
    mov x1,eax
  .elseif ebx > _v_win_x2
    mov eax,_v_win_x2
    mov x2,eax
  .elseif ecx < _v_win_y1
    mov eax,_v_win_y1
    mov y1,eax
  .elseif edx > _v_win_y2
    mov eax,_v_win_y2
    mov y2,eax
  .endif
  assume eax:dword,ebx:dword,ecx:dword,edx:dword

  g_copy_init

  mov eax,x2
  sub eax,x1
  inc eax
  mov xl,eax
  mul _v_bypp
  mov xlb,eax

  mov eax,y2
  sub eax,y1
  inc eax
  mov yl,eax

  mov eax,y1
  mul _v_xb
  mov ecx,eax
  mov eax,x1
  mul _v_bypp
  add ecx,eax
  mov _off,ecx  ;ECX used ...

  mov eax,y1
  mul _v_xbpsl
  add eax,ecx
  mov _offx,eax
    
  mov eax,_v_acctype  ;access type
  jmp dptr[eax+offset g_copyblk_type]

copy2_modex::   ;;mx_*
  and cl,3      ;...here
  mov al,1
  shl al,cl
  mov modex_plane_wr,al
  mov eax,_v_xb
  sub eax,xlb
  ;EAX = sadd
  add eax,3
  and al,0ffh-3
  mov sadd,eax
  shr eax,2
  mov dadd,eax
  mov eax,xl
  mov _xl2c,al
  and _xl2c,3
  shr eax,2
  mov ebx,eax   ;XL/4
  mov eax,_off
  shr eax,2
  mov _off2,eax
  mov _pc,4  ;Plane counter
  mov dx,vga_SC_INDEX 
  mov al,02h
  mov ah,modex_plane_wr
  out dx,ax     ; enable writes to 1st plane
mx_l2:
  mov esi,_v_buffer
  add esi,_off
  mov edi,_v_linear
  add edi,_off2

  .if _xl2c
    inc ebx
    sub sadd,4
    dec dadd
  .endif
  test ebx,ebx   ;this can happen when xl=3 or less
  jz mx_z1

  mov eax,yl
mx_l1:
  mov ecx,ebx
@@:
  movsb
  add esi,3
  dec ecx
  jnz @b
  add esi,sadd
  add edi,dadd
  dec eax
  jnz mx_l1

mx_z1:
  .if _xl2c
    dec ebx
    add sadd,4
    inc dadd
    dec _xl2c
  .endif

  dec _pc
  jz done
  inc _off
  mov ah,modex_plane_wr
  shl ah,1
  .if ah==16
    mov ah,1
    inc _off2
  .endif
  mov modex_plane_wr,ah
  mov al,02h
  out dx,ax     ; enable writes to plane
  jmp mx_l2

copy2_vesa::    ;;v_*
  mov eax,_v_xb
  sub eax,xlb
;  jz v_noadd
  ;EAX = sadd
  mov sadd,eax
  mov esi,_v_buffer
  mov edi,_v_linear
  mov eax,_off
  add esi,eax
  mov eax,_offx
  mov edx,eax
  and edx,0ffffh
  shr eax,16
;  xor edx,edx
;  mov ebx,64*1024
;  div ebx
  ; al=bank # required
  ; edx=offset required (remainder)
  add edi,edx
  .if al!=vesa_current_bank
    callp vesa_setbank,al
  .endif

  mov ebx,yl
  mov eax,64*1024 ;when this reaches 0 then we must switch to next bank
  sub eax,edx
  mov edx,eax
  ;copy a scan line
@@:
  mov ecx,xlb
  .if edx<=ecx
    mov ecx,edx  ;use rest of bank
    copyECX
    mov edi,_v_linear
    mov ecx,xlb
    sub ecx,edx
    mov edx,64*1024
    sub edx,ecx
    call vesa_nextbank
    copyECX      ;copy rest of scan line
  .else
    sub edx,ecx
    copyECX      ;copy entire scan line
  .endif
  add esi,sadd
  ;Add sadd to EDI
  .if edx<=sadd
    call vesa_nextbank
    mov edi,_v_linear
    mov eax,sadd
    sub eax,edx
    add edi,eax
    mov edx,64*1024
    sub edx,eax
  .else
    sub edx,sadd
    add edi,sadd
  .endif
  dec ebx
  jnz @b
  jmp done

copy2_vesax::    ;;vx_*
  mov eax,_v_xb
  sub eax,xlb
;  jz vx_noadd
  ;EAX = sadd
  mov sadd,eax
  add eax,_v_xbpsl
  mov dadd,eax
  mov esi,_v_buffer
  mov edi,_v_linear
  mov eax,_off
  add esi,eax
  mov eax,_offx
  mov edx,eax
  and edx,0ffffh
  shr eax,16
;  xor edx,edx
;  mov ebx,64*1024
;  div ebx
  ; al=bank # required
  ; edx=offset required (remainder)
  add edi,edx
  .if al!=vesa_current_bank
    callp vesa_setbank,al
  .endif

  mov ebx,yl
  mov eax,64*1024 ;when this reaches 0 then we must switch to next bank
  sub eax,edx
  mov edx,eax
  ;copy a scan line
@@:
  mov ecx,xlb
  .if edx<=ecx
    push ecx
    mov ecx,edx  ;use rest of bank
    copyECX
    mov edi,_v_linear
    pop ecx
    sub ecx,edx
    mov edx,64*1024
    call vesa_nextbank
    sub edx,ecx
    copyECX
  .else
    sub edx,ecx
    copyECX
  .endif
  add esi,sadd
  ;Add dadd to EDI
  .if edx<=dadd
    call vesa_nextbank
    mov edi,_v_linear
    mov eax,dadd
    sub eax,edx
    add edi,eax
    mov edx,64*1024
    sub edx,eax
  .else
    sub edx,dadd
    add edi,dadd
  .endif
  dec ebx
  jnz @b
  jmp done

copy2_linearx::   ;;lx_*
  mov eax,_v_xb
  sub eax,xlb
  jz lx_noadd
  ;EAX = sadd
  mov sadd,eax
  add eax,_v_xbpsl
  mov dadd,eax
  mov edi,_v_linear
  mov esi,_v_buffer
  add esi,_offx
  add edi,_offx

@@:
  mov ecx,xlb
  copyECX
   ;copy one line
  add esi,sadd
  add edi,dadd
  dec yl
  jnz @b
  jmp done

lx_noadd:
  mov eax,_v_xb
  mul _v_y
  mov ecx,eax
  mov edi,_v_linear
  mov esi,_v_buffer
  add esi,_offx
  add edi,_offx
@@:
  mov ecx,xlb
  dec yl
  jnz @b

copy2_linear::   ;;l_*
  mov eax,_v_xb
  sub eax,xlb
  jz l_noadd
  ;EAX = sadd
  mov sadd,eax
  mov edi,_v_linear
  mov esi,_v_buffer
  add esi,_off
  add edi,_off
  mov edx,sadd

@@:
  mov ecx,xlb
  copyECX
  add esi,edx
  add edi,edx
  dec yl
  jnz @b
  jmp done

l_noadd:
  mov eax,_v_xb
  mul yl
  mov ecx,eax
  mov edi,_v_linear
  mov esi,_v_buffer
  add esi,_off
  add edi,_off
  copyECX

done:

  g_copy_uninit

niv:   ;not in view
  popad
  ret
g_copyblk endp
