include src\qlib.inc
include src\math.inc
include math.inc
include errno.inc
include string.inc

.code

log proc, val:REAL8
    mov     [errno], 0                          ; clear matherror
    fld     val                                 ; load the value
    ftst                                        ; compare with zero
    fstsw   ax                                  ; save status word in AX
    _fwait                                       ; wait this shit be idle
    sahf                                        ; load flags with it
    .if carry?                                  ; jump if value < 0
      mov     [errno], EDOM                     ; domain error
bad:
      ffree st(0)
      fld REAL8 PTR _HugeValue
      fchs  ;Negative
      _fwait
      ret
    .endif
    .if zero?                                   ; jump if zero
      mov     [errno], ERANGE                   ; range error
      jmp bad
    .endif

    fldln2                                      ; load natural log of 2
    fxch    st(1)                               ; xchange it with value
    fyl2x                                       ; calc y=log2(x)

    CleanREAL8

    _fwait
    ret
log ENDP

_endseg

end
