//#define DEBUG   ;test file IO
//#define DEBUG2  ;test pasm
//#define DEBUG3  ;test readln

// PreASMmbler v2.01  32bit
//  By:Peter Quiring

/*----------------------------------------------------------------------------
 Version 2.01 NEW : 'i' memicmp used.  Cause H2INC generates Uppercase
 Version 2.00b NEW : Bug fix : Could crash if INCLUDE environment was not set
                   : Does not omit 'comment' blocks from output which was
                   : making tracking errors TOO hard.
 Version 2.00a NEW : Deletes output file on error (so Q BAT files can detect
                     error)
 Version 2.00 NEW : Now outputs all files into \\PASM.TMP
                    Each file that is possible included is processed
                    and placed into the dir.
 Version 1.20 NEW : handles single quotes into double quotes (you no longer
                    need to double them up yourself
 Version 1.11 NEW : expand /t into tab
 Version 1.10 NEW : no extra spaces between 'include' and 'file' were allowed
                  : major improvment in error handling
                  : \" will work now (use to have to use "" - which will still work)
                  : null strings now work
 Version 1.04 NEW : Now the INCLUDE enviro str can have multiple paths
                  : seperated by ;
 Version 1.03 NEW : 32bit using DOS32
                  : Buffered input/output  (greatly increases speed!)
                  : \r=13, \n=10, \0=0  (\n use to =13,10)
 Version 1.02 NEW : \0 will insert a ,0, into the string
 Version 1.01 NEW : Now handles comment blocks

known bugs: v1.0
 -none
known bugs: v0.1 eta
 -can't not have ; or ' or " within quotes

   Current version
limitations:
 -none
future improvments:
 -merge duplicate strings (now I could with 32bit power - so much RAM)
----------------------------------------------------------------------------*/

#include <qlib.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <fcntl.h>

#include "misc.h"

#define nof 128
byte buf[256];  //current line buffer
byte noff;      //# of files found so far
byte cf;        //current file in use
word cln;
byte *bufo1;
byte *bufo2;
word bufp1,bufp2;
byte * bufin;
word bufip;
word bufis;
byte files[nof][128];
byte ffn[128];  // find filename
word cnum;      // current string number
int ho1;        // handle out for ASM file
int ho2;        // handle out for special data segment (_str_.tmp)
int hi;         // current file handle
byte foundit;   // flag to indicate we found ;;include_pasm_strings;;
byte str[255];
byte str2[255];
byte str3[255];
byte enter[3]={13,10,0};
byte *inc;    // INCLUDE name from enviroment
word incsiz;  // size of inc string
byte TEOF;   //eof
byte anulstr;

  //Protos
void flush(void);
void prefile(void);
void out(void);
void out2nd(void);
void FindFile(char *file);

#define PASM
#include "error.h"
#include "readln.h"
#include "pasm.h"

void main(void) {
  byte a;

  files[0][0]=0;
  printf("Pre Assembler v2.01 32bit (by : Peter Quiring)\n");
  ho1=ho2=hi=0;
  bufp1=bufp2=0;
  noff=cf=foundit=cnum=0;
  if (_argc!=2) error("Usage: PASM 'file.asm'");
  bufo1=GetRam(bufsiz);
  bufo2=GetRam(bufsiz);
  bufin=GetRam(bufsiz);
  setup();
  FindFile(_argv[1]);
  strcpy(files[0],ffn);
  while (cf<=noff) {
    prefile();
    cf++;
  }
  flush();
  if (!foundit) printf("Warning:';;include_pasm_strings;;' was not found\n");
  printf("Complete!\n\n");
//  for (a=0;a<=noff;a++)
//    printf(" FILE %u:%s\n",a,files[a]);
  exit(0);
}

/*/
Todo :
- make sure 1st file does not contain a \

/*/
