;File-LZ Speed compression test program

include qlib.inc
include string.inc
include stdio.inc
include conio.inc
include dos.inc
include alloc.inc

include compress.inc

.data

ibuf dd ?
obuf dd ?
hi dw ?
ho dw ?

.code

main proc
  callp printf,"L-Z Speed compression test\n\n"

  cmp _argc,3
  jne usage

  mov eax,_argv
  mov ebx,[eax+4]   ;_argv[1]
  mov ecx,[eax+8]   ;_argv[2]
  callp open,ebx,O_BINARY or O_RDONLY
  cmp ax,-1
  je fileio
  mov hi,ax
  callp open,ecx,O_BINARY or O_WRONLY or O_CREAT or O_TRUNC
  cmp ax,-1
  je fileio
  mov ho,ax

  callp filelength,hi
  mov ebx,eax

  callp malloc,ebx
  cmp eax,-1
  je ram
  mov ibuf,eax
  mov ecx,ebx
  shl ecx,1  ;just in case it expands in size
  callp malloc,ecx
  cmp eax,-1
  je ram
  mov obuf,eax

  callp read,hi,ibuf,ebx
  cmp eax,ebx
  jne fileio

  callp CompressBuffer,obuf,ecx,ibuf,ebx,COMP_NOSTORE,COMP_LZ

  cmp eax,ERROR
  je compfail

  mov ebx,eax

  callp printf,"Compressed size = %d\n",ebx

  callp write,ho,obuf,ebx
  callp close,ho

done:

  ret

usage:
  callp printf,"usage!"
  ret

fileio:
  callp printf,"fileio!"
  ret

ram:
  callp printf,"no ram!"
  ret

compfail:
  callp printf,"CompressBuffer() failed!"
  ret

main endp

end
